!+ Subroutine to implement the MRF UMIST parametrization.                          RAD_ALL.5218  
!                                                                                  RAD_ALL.5219  
! Purpose:                                                                         RAD_ALL.5220  
!   Effective Radii are calculated in accordance with this                         RAD_ALL.5221  
!   parametrization.                                                               RAD_ALL.5222  
!                                                                                  RAD_ALL.5223  
! Method:                                                                          RAD_ALL.5224  
!   The number density of CCN is found from the concentration                      RAD_ALL.5225  
!   of aerosols, if available. This yields the number density of                   RAD_ALL.5226  
!   droplets: if aerosols are not present, the number of droplets                  RAD_ALL.5227  
!   is fixed. Effective radii are calculated from the number of                    RAD_ALL.5228  
!   droplets and the LWC. Limits are applied to these values. In                   RAD_ALL.5229  
!   deep convective clouds fixed values are assumed.                               RAD_ALL.5230  
!                                                                                  RAD_ALL.5231  
! Current Owner of Code: J. M. Edwards                                             RAD_ALL.5232  
!                                                                                  RAD_ALL.5233  
! History:                                                                         RAD_ALL.5234  
!       Version         Date                    Comment                            RAD_ALL.5235  
!       4.0             27-07-95                Original Code                      RAD_ALL.5236  
!                                               (J. M. Edwards)                    RAD_ALL.5237  
!       4.4             15-09-97                Accumulation-mode                  RAD_ALL.5238  
!                                               and dissolved sulphate             RAD_ALL.5239  
!                                               passed directly to                 RAD_ALL.5240  
!                                               this routine to allow              RAD_ALL.5241  
!                                               the indirect effect to             RAD_ALL.5242  
!                                               be used without                    RAD_ALL.5243  
!                                               aerosols being needed              RAD_ALL.5244  
!                                               in the spectral file.              RAD_ALL.5245  
!                                               (J. M. Edwards)                    RAD_ALL.5246  
!                                                                                  RAD_ALL.5247  
! Description of Code:                                                             RAD_ALL.5248  
!   FORTRAN 77  with extensions listed in documentation.                           RAD_ALL.5249  
!                                                                                  RAD_ALL.5250  
!- ---------------------------------------------------------------------           RAD_ALL.5251  
      SUBROUTINE R2_RE_MRF_UMIST(N_PROFILE, NLEVS, NCLDS                           RAD_ALL.5252  
     &   , I_GATHER                                                                RAD_ALL.5253  
     &   , L_AEROSOL_CCN, ACCUM_SULPHATE, DISS_SULPHATE                            RAD_ALL.5254  
     &   , I_CLOUD_REPRESENTATION                                                  RAD_ALL.5255  
     &   , LAND_G, DENSITY_AIR, CONDENSED_MIX_RATIO, CC_DEPTH                      RAD_ALL.5256  
     &   , CONDENSED_RE                                                            RAD_ALL.5257  
     &   , NTOT_DIAG_G                                                             RAD_ALL.5258  
     &   , STRAT_LWC_DIAG_G                                                        RAD_ALL.5259  
     &   , SO4_CCN_DIAG_G                                                          RAD_ALL.5260  
     &   , SULP_DIM1, SULP_DIM2                                                    RAD_ALL.5261  
     &   , NPD_FIELD, NPD_PROFILE, NPD_LAYER, NPD_AEROSOL_SPECIES                  RAD_ALL.5262  
     &   )                                                                         RAD_ALL.5263  
!                                                                                  RAD_ALL.5264  
!                                                                                  RAD_ALL.5265  
!                                                                                  RAD_ALL.5266  
      IMPLICIT NONE                                                                RAD_ALL.5267  
!                                                                                  RAD_ALL.5268  
!                                                                                  RAD_ALL.5269  
!     COMDECKS INCLUDED:                                                           RAD_ALL.5270  
C*L------------------COMDECK C_PI---------------------------------------           C_PI.2     
CLL                                                                                C_PI.3     
CLL 4.0 19/09/95  New value for PI. Old value incorrect                            C_PI.4     
CLL               from 12th decimal place. D. Robinson                             C_PI.5     
CLL                                                                                C_PI.6     
      REAL PI,PI_OVER_180,RECIP_PI_OVER_180                                        C_PI.7     
                                                                                   C_PI.8     
      PARAMETER(                                                                   C_PI.9     
     & PI=3.14159265358979323846, ! Pi                                             C_PI.10    
     & PI_OVER_180 =PI/180.0,   ! Conversion factor degrees to radians             C_PI.11    
     & RECIP_PI_OVER_180 = 180.0/PI ! Conversion factor radians to                 C_PI.12    
     &                              ! degrees                                      C_PI.13    
     & )                                                                           C_PI.14    
C*----------------------------------------------------------------------           C_PI.15    
                                                                                   C_PI.16    
C*L-----------COMDECK C_DENSTY FOR SUBROUTINE SF_EXCH----------                    C_DENSTY.2     
C RHOSEA    = density of sea water (kg/m3)                                         C_DENSTY.3     
C RHO_WATER = density of pure water (kg/m3)                                        C_DENSTY.4     
      REAL RHOSEA,RHO_WATER                                                        C_DENSTY.5     
                                                                                   C_DENSTY.6     
      PARAMETER(RHOSEA = 1000.0,                                                   C_DENSTY.7     
     &          RHO_WATER = 1000.0)                                                C_DENSTY.8     
C*----------------------------------------------------------------------           C_DENSTY.9     
!                                                                                  C_MICRO.2     
! Description:                                                                     C_MICRO.3     
!                                                                                  C_MICRO.4     
!  Contains various parameters for the SW effective radius                         C_MICRO.5     
!  parametrisation, defined for land and sea areas.                                C_MICRO.6     
!                                                                                  C_MICRO.7     
!  NTOT is the number concentration (m-3) of activated CCN;                        C_MICRO.8     
!  KPARAM is the ratio of volume mean radius to effective radius;                  C_MICRO.9     
!  DCONRE is the effective radius (m) for deep convective clouds.                  C_MICRO.10    
!                                                                                  C_MICRO.11    
! Current Code Owner: Andy Jones                                                   C_MICRO.12    
!                                                                                  C_MICRO.13    
! History:                                                                         C_MICRO.14    
!                                                                                  C_MICRO.15    
! Version   Date     Comment                                                       C_MICRO.16    
! -------   ----     -------                                                       C_MICRO.17    
!    1     040894   Original code.    Andy Jones                                   C_MICRO.18    
!                                                                                  C_MICRO.19    
      REAL NTOT_LAND,                                                              C_MICRO.20    
     &     NTOT_SEA,                                                               C_MICRO.21    
     &     KPARAM_LAND,                                                            C_MICRO.22    
     &     KPARAM_SEA,                                                             C_MICRO.23    
     &     DCONRE_LAND,                                                            C_MICRO.24    
     &     DCONRE_SEA                                                              C_MICRO.25    
                                                                                   C_MICRO.26    
      PARAMETER ( NTOT_LAND = 6.0E08,                                              C_MICRO.27    
     &            NTOT_SEA = 1.5E08,                                               C_MICRO.28    
     &            KPARAM_LAND = 0.67,                                              C_MICRO.29    
     &            KPARAM_SEA = 0.80,                                               C_MICRO.30    
     &            DCONRE_LAND = 9.5E-06,                                           C_MICRO.31    
     &            DCONRE_SEA = 13.5E-06 )                                          C_MICRO.32    
!     ------------------------------------------------------------------           DIMFIX3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       DIMFIX3A.3     
!                                                                                  DIMFIX3A.4     
!     MODULE TO SET INTERNAL DIMENSIONS TIED TO ALGORITHMS,                        DIMFIX3A.5     
!     MOSTLY FOR CLOUDS.                                                           DIMFIX3A.6     
!                                                                                  DIMFIX3A.7     
      INTEGER                                                                      DIMFIX3A.8     
     &     NPD_CLOUD_COMPONENT                                                     DIMFIX3A.9     
!             NUMBER OF COMPONENTS OF CLOUDS                                       DIMFIX3A.10    
     &   , NPD_CLOUD_TYPE                                                          DIMFIX3A.11    
!             NUMBER OF PERMITTED TYPES OF CLOUDS.                                 DIMFIX3A.12    
     &   , NPD_CLOUD_REPRESENTATION                                                DIMFIX3A.13    
!             NUMBER OF PERMITTED REPRESENTATIONS OF CLOUDS.                       DIMFIX3A.14    
     &   , NPD_OVERLAP_COEFF                                                       DIMFIX3A.15    
!             NUMBER OF OVERLAP COEFFICIENTS FOR CLOUDS                            DIMFIX3A.16    
     &   , NPD_SOURCE_COEFF                                                        DIMFIX3A.17    
!             NUMBER OF COEFFICIENTS FOR TWO-STREAM SOURCES                        DIMFIX3A.18    
     &   , NPD_REGION                                                              DIMFIX3A.19    
!             NUMBER OF REGIONS IN A LAYER                                         DIMFIX3A.20    
!                                                                                  DIMFIX3A.21    
      PARAMETER(                                                                   DIMFIX3A.22    
     &     NPD_CLOUD_COMPONENT=4                                                   DIMFIX3A.23    
     &   , NPD_CLOUD_TYPE=4                                                        DIMFIX3A.24    
     &   , NPD_CLOUD_REPRESENTATION=4                                              DIMFIX3A.25    
     &   , NPD_OVERLAP_COEFF=18                                                    DIMFIX3A.26    
     &   , NPD_SOURCE_COEFF=2                                                      DIMFIX3A.27    
     &   , NPD_REGION=3                                                            DIMFIX3A.28    
     &   )                                                                         DIMFIX3A.29    
!                                                                                  DIMFIX3A.30    
!     ------------------------------------------------------------------           DIMFIX3A.31    
!     ------------------------------------------------------------------           CLDCMP3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       CLDCMP3A.3     
!                                                                                  CLDCMP3A.4     
!     MODULE TO SET COMPONENTS OF CLOUDS.                                          CLDCMP3A.5     
!                                                                                  CLDCMP3A.6     
      INTEGER                                                                      CLDCMP3A.7     
     &     IP_CLCMP_ST_WATER                                                       CLDCMP3A.8     
!             STRATIFORM WATER DROPLETS                                            CLDCMP3A.9     
     &   , IP_CLCMP_ST_ICE                                                         CLDCMP3A.10    
!             STRATIFORM ICE CRYSTALS                                              CLDCMP3A.11    
     &   , IP_CLCMP_CNV_WATER                                                      CLDCMP3A.12    
!             CONVECTIVE WATER DROPLETS                                            CLDCMP3A.13    
     &   , IP_CLCMP_CNV_ICE                                                        CLDCMP3A.14    
!             CONVECTIVE ICE CRYSTALS                                              CLDCMP3A.15    
!                                                                                  CLDCMP3A.16    
      PARAMETER(                                                                   CLDCMP3A.17    
     &     IP_CLCMP_ST_WATER=1                                                     CLDCMP3A.18    
     &   , IP_CLCMP_ST_ICE=2                                                       CLDCMP3A.19    
     &   , IP_CLCMP_CNV_WATER=3                                                    CLDCMP3A.20    
     &   , IP_CLCMP_CNV_ICE=4                                                      CLDCMP3A.21    
     &   )                                                                         CLDCMP3A.22    
!                                                                                  CLDCMP3A.23    
!     ------------------------------------------------------------------           CLDCMP3A.24    
!     ------------------------------------------------------------------           CLREPP3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       CLREPP3A.3     
!                                                                                  CLREPP3A.4     
!     MODULE TO SET REPRESENTATIONS OF CLOUDS.                                     CLREPP3A.5     
!                                                                                  CLREPP3A.6     
!     REPRESENTATIONS                                                              CLREPP3A.7     
      INTEGER                                                                      CLREPP3A.8     
     &     IP_CLOUD_HOMOGEN                                                        CLREPP3A.9     
!             ALL COMPONENTS ARE MIXED HOMOGENEOUSLY                               CLREPP3A.10    
     &   , IP_CLOUD_ICE_WATER                                                      CLREPP3A.11    
!             ICE AND WATER CLOUDS ARE TREATED SEPARATELY                          CLREPP3A.12    
     &   , IP_CLOUD_CONV_STRAT                                                     CLREPP3A.13    
!             CLOUDS ARE DIVIDED INTO HOMOGENEOUSLY MIXED                          CLREPP3A.14    
!             STRATIFORM AND CONVECTIVE PARTS                                      CLREPP3A.15    
     &   , IP_CLOUD_CSIW                                                           CLREPP3A.16    
!             CLOUDS DIVIDED INTO ICE AND WATER PHASES AND                         CLREPP3A.17    
!             INTO STRATIFORM AND CONVECTIVE COMPONENTS.                           CLREPP3A.18    
!                                                                                  CLREPP3A.19    
      PARAMETER(                                                                   CLREPP3A.20    
     &     IP_CLOUD_HOMOGEN=1                                                      CLREPP3A.21    
     &   , IP_CLOUD_ICE_WATER=2                                                    CLREPP3A.22    
     &   , IP_CLOUD_CONV_STRAT=3                                                   CLREPP3A.23    
     &   , IP_CLOUD_CSIW=4                                                         CLREPP3A.24    
     &   )                                                                         CLREPP3A.25    
!                                                                                  CLREPP3A.26    
!     TYPES OF CLOUDS:                                                             CLREPP3A.27    
      INTEGER                                                                      CLREPP3A.28    
     &     NP_CLOUD_TYPE(NPD_CLOUD_REPRESENTATION)                                 CLREPP3A.29    
!             NUMBER OF TYPE OF CLOUDS IN REPRESENTATION                           CLREPP3A.30    
!                                                                                  CLREPP3A.31    
      INTEGER                                                                      CLREPP3A.32    
     &     IP_CLOUD_TYPE_MAP(NPD_CLOUD_COMPONENT                                   CLREPP3A.33    
     &       , NPD_CLOUD_REPRESENTATION)                                           CLREPP3A.34    
!            MAP OF COMPONENTS CONTRIBUTING TO TYPES OF CLOUDS                     CLREPP3A.35    
!                                                                                  CLREPP3A.36    
!     ------------------------------------------------------------------           CLREPP3A.37    
!                                                                                  RAD_ALL.5277  
!                                                                                  RAD_ALL.5278  
!     DUMMY ARGUMENTS:                                                             RAD_ALL.5279  
!                                                                                  RAD_ALL.5280  
!     SIZES OF ARRAYS:                                                             RAD_ALL.5281  
      INTEGER   !, INTENT(IN)                                                      RAD_ALL.5282  
     &     NPD_FIELD                                                               RAD_ALL.5283  
!             SIZE OF INPUT FIELDS TO THE RADIATION                                RAD_ALL.5284  
     &   , NPD_PROFILE                                                             RAD_ALL.5285  
!             MAXIMUM NUMBER OF PROFILES                                           RAD_ALL.5286  
     &   , NPD_LAYER                                                               RAD_ALL.5287  
!             MAXIMUM NUMBER OF LAYERS                                             RAD_ALL.5288  
     &   , NPD_AEROSOL_SPECIES                                                     RAD_ALL.5289  
!             MAXIMUM NUMBER OF AEROSOL SPECIES                                    RAD_ALL.5290  
     &   , SULP_DIM1                                                               RAD_ALL.5291  
!             1ST DIMENSION OF ARRAYS OF SULPHATE                                  RAD_ALL.5292  
     &   , SULP_DIM2                                                               RAD_ALL.5293  
!             2ND DIMENSION OF ARRAYS OF SULPHATE                                  RAD_ALL.5294  
!                                                                                  RAD_ALL.5295  
      INTEGER   !, INTENT(IN)                                                      RAD_ALL.5296  
     &     N_PROFILE                                                               RAD_ALL.5297  
!             NUMBER OF ATMOSPHERIC PROFILES                                       RAD_ALL.5298  
     &   , NLEVS                                                                   RAD_ALL.5299  
!             NUMBER OF LEVELS                                                     RAD_ALL.5300  
     &   , NCLDS                                                                   RAD_ALL.5301  
!             NUMBER OF CLOUDY LEVELS                                              RAD_ALL.5302  
!                                                                                  RAD_ALL.5303  
      INTEGER   !, INTENT(IN)                                                      RAD_ALL.5304  
     &     I_GATHER(NPD_FIELD)                                                     RAD_ALL.5305  
!             LIST OF POINTS TO BE GATHERED                                        RAD_ALL.5306  
      LOGICAL   !, INTENT(IN)                                                      RAD_ALL.5307  
     &     LAND_G(NPD_PROFILE)                                                     RAD_ALL.5308  
!             GATHERED MASK FOR LAND POINTS                                        RAD_ALL.5309  
      INTEGER   !, INTENT(IN)                                                      RAD_ALL.5310  
     &     I_CLOUD_REPRESENTATION                                                  RAD_ALL.5311  
!             REPRESENTATION OF CLOUDS                                             RAD_ALL.5312  
!                                                                                  RAD_ALL.5313  
!     VARIABLES FOR AEROSOLS                                                       RAD_ALL.5314  
      LOGICAL   !, INTENT(IN)                                                      RAD_ALL.5315  
     &     L_AEROSOL_CCN                                                           RAD_ALL.5316  
!             FLAG TO USE AEROSOLS TO FIND CCN.                                    RAD_ALL.5317  
      REAL      !, INTENT(IN)                                                      RAD_ALL.5318  
     &     ACCUM_SULPHATE(SULP_DIM1, SULP_DIM2)                                    RAD_ALL.5319  
!             MIXING RATIOS OF ACCUMULATION MODE SULPHATE                          RAD_ALL.5320  
     &   , DISS_SULPHATE(SULP_DIM1, SULP_DIM2)                                     RAD_ALL.5321  
!             MIXING RATIOS OF DISSOLVED SULPHATE                                  RAD_ALL.5322  
!                                                                                  RAD_ALL.5323  
      REAL      !, INTENT(IN)                                                      RAD_ALL.5324  
     &     DENSITY_AIR(NPD_PROFILE, NPD_LAYER)                                     RAD_ALL.5325  
!             DENSITY OF AIR                                                       RAD_ALL.5326  
!                                                                                  RAD_ALL.5327  
      REAL      !, INTENT(IN)                                                      RAD_ALL.5328  
     &     CONDENSED_MIX_RATIO(NPD_PROFILE, 0: NPD_LAYER                           RAD_ALL.5329  
     &        , NPD_CLOUD_COMPONENT)                                               RAD_ALL.5330  
!             MIXING RATIOS OF CONDENSED SPECIES                                   RAD_ALL.5331  
     &   , CC_DEPTH(NPD_PROFILE)                                                   RAD_ALL.5332  
!             DEPTH OF CONVECTIVE CLOUD                                            RAD_ALL.5333  
!                                                                                  RAD_ALL.5334  
      REAL      !, INTENT(OUT)                                                     RAD_ALL.5335  
     &     CONDENSED_RE(NPD_PROFILE, 0: NPD_LAYER, NPD_CLOUD_COMPONENT)            RAD_ALL.5336  
!             EFFECTIVE RADII OF CONDENSED COMPONENTS OF CLOUDS                    RAD_ALL.5337  
!                                                                                  RAD_ALL.5338  
      REAL      !, INTENT(OUT)                                                     RAD_ALL.5339  
     &     NTOT_DIAG_G(NPD_PROFILE, NPD_LAYER)                                     RAD_ALL.5340  
!             DIAGNOSTIC ARRAY FOR NTOT (GATHERED)                                 RAD_ALL.5341  
     &   , STRAT_LWC_DIAG_G(NPD_PROFILE, NPD_LAYER)                                RAD_ALL.5342  
!             DIAGNOSTIC ARRAY FOR STRATIFORM LWC (GATHERED)                       RAD_ALL.5343  
     &   , SO4_CCN_DIAG_G(NPD_PROFILE, NPD_LAYER)                                  RAD_ALL.5344  
!             DIAGNOSTIC ARRAY FOR SO4 CCN MASS CONC (GATHERED)                    RAD_ALL.5345  
!                                                                                  RAD_ALL.5346  
!                                                                                  RAD_ALL.5347  
!     LOCAL VARIABLES:                                                             RAD_ALL.5348  
      INTEGER                                                                      RAD_ALL.5349  
     &     I                                                                       RAD_ALL.5350  
!             LOOP VARIABLE                                                        RAD_ALL.5351  
     &   , L                                                                       RAD_ALL.5352  
!             LOOP VARIABLE                                                        RAD_ALL.5353  
!                                                                                  RAD_ALL.5354  
      REAL                                                                         RAD_ALL.5355  
     &     TOTAL_MIX_RATIO_ST(NPD_PROFILE)                                         RAD_ALL.5356  
!             TOTAL MIXING RATIO OF WATER SUBSTANCE IN STRATIFORM CLOUD            RAD_ALL.5357  
     &   , TOTAL_MIX_RATIO_CNV(NPD_PROFILE)                                        RAD_ALL.5358  
!             TOTAL MIXING RATIO OF WATER SUBSTANCE IN STRATIFORM CLOUD            RAD_ALL.5359  
!                                                                                  RAD_ALL.5360  
      REAL                                                                         RAD_ALL.5361  
     &     N_DROP(NPD_PROFILE, NPD_LAYER)                                          RAD_ALL.5362  
!             NUMBER DENSITY OF DROPLETS                                           RAD_ALL.5363  
     &   , KPARAM                                                                  RAD_ALL.5364  
!             RATIO OF CUBES OF VOLUME RADIUS TO EFFECTIVE RADIUS                  RAD_ALL.5365  
!                                                                                  RAD_ALL.5366  
!     FIXED CONSTANTS OF THE PARAMETRIZATION:                                      RAD_ALL.5367  
      REAL                                                                         RAD_ALL.5368  
     &     RE_UPPER_BOUND                                                          RAD_ALL.5369  
!             UPPER BOUND ON EFFECTIVE RADII                                       RAD_ALL.5370  
     &   , RE_LOWER_BOUND                                                          RAD_ALL.5371  
!             LOWER BOUND ON EFFECTIVE RADII                                       RAD_ALL.5372  
     &   , DEEP_CONVECTIVE_CLOUD                                                   RAD_ALL.5373  
!             THRESHOLD VALUE FOR DEEP CONVECTIVE CLOUD                            RAD_ALL.5374  
      PARAMETER(                                                                   RAD_ALL.5375  
     &     RE_UPPER_BOUND=3.7E-05                                                  RAD_ALL.5376  
     &   , RE_LOWER_BOUND=3.5E-07                                                  RAD_ALL.5377  
     &   , DEEP_CONVECTIVE_CLOUD=5.0E+02                                           RAD_ALL.5378  
     &   )                                                                         RAD_ALL.5379  
!                                                                                  RAD_ALL.5380  
!                                                                                  RAD_ALL.5381  
!                                                                                  RAD_ALL.5382  
!     CALCULATE THE NUMBER DENSITY OF DROPLETS                                     RAD_ALL.5383  
      CALL R2_FIND_NUMBER_DROP(N_PROFILE, NLEVS, NCLDS                             RAD_ALL.5384  
     &   , I_GATHER                                                                RAD_ALL.5385  
     &   , DENSITY_AIR, L_AEROSOL_CCN                                              RAD_ALL.5386  
     &   , ACCUM_SULPHATE, DISS_SULPHATE                                           RAD_ALL.5387  
     &   , LAND_G                                                                  RAD_ALL.5388  
     &   , N_DROP                                                                  RAD_ALL.5389  
     &   , SO4_CCN_DIAG_G                                                          RAD_ALL.5390  
     &   , SULP_DIM1, SULP_DIM2                                                    RAD_ALL.5391  
     &   , NPD_FIELD, NPD_PROFILE, NPD_LAYER, NPD_AEROSOL_SPECIES                  RAD_ALL.5392  
     &   )                                                                         RAD_ALL.5393  
!                                                                                  RAD_ALL.5394  
      DO I=NLEVS+1-NCLDS, NLEVS                                                    RAD_ALL.5395  
!                                                                                  RAD_ALL.5396  
!        FIND THE TOTAL MIXING RATIO OF WATER SUBSTANCE IN THE CLOUD               RAD_ALL.5397  
!        AS IMPLIED BY THE REPRESENTATION.                                         RAD_ALL.5398  
         IF (I_CLOUD_REPRESENTATION.EQ.IP_CLOUD_CONV_STRAT) THEN                   RAD_ALL.5399  
            DO L=1, N_PROFILE                                                      RAD_ALL.5400  
               TOTAL_MIX_RATIO_ST(L)                                               RAD_ALL.5401  
     &            =CONDENSED_MIX_RATIO(L, I, IP_CLCMP_ST_WATER)                    RAD_ALL.5402  
     &            +CONDENSED_MIX_RATIO(L, I, IP_CLCMP_ST_ICE)                      RAD_ALL.5403  
               TOTAL_MIX_RATIO_CNV(L)                                              RAD_ALL.5404  
     &            =CONDENSED_MIX_RATIO(L, I, IP_CLCMP_CNV_WATER)                   RAD_ALL.5405  
     &            +CONDENSED_MIX_RATIO(L, I, IP_CLCMP_CNV_ICE)                     RAD_ALL.5406  
            ENDDO                                                                  RAD_ALL.5407  
         ELSE IF (I_CLOUD_REPRESENTATION.EQ.IP_CLOUD_CSIW) THEN                    RAD_ALL.5408  
            DO L=1, N_PROFILE                                                      RAD_ALL.5409  
               TOTAL_MIX_RATIO_ST(L)                                               RAD_ALL.5410  
     &            =CONDENSED_MIX_RATIO(L, I, IP_CLCMP_ST_WATER)                    RAD_ALL.5411  
               TOTAL_MIX_RATIO_CNV(L)                                              RAD_ALL.5412  
     &            =CONDENSED_MIX_RATIO(L, I, IP_CLCMP_CNV_WATER)                   RAD_ALL.5413  
            ENDDO                                                                  RAD_ALL.5414  
         ENDIF                                                                     RAD_ALL.5415  
         DO L=1, N_PROFILE                                                         RAD_ALL.5416  
            IF (LAND_G(L)) THEN                                                    RAD_ALL.5417  
               KPARAM=KPARAM_LAND                                                  RAD_ALL.5418  
            ELSE                                                                   RAD_ALL.5419  
               KPARAM=KPARAM_SEA                                                   RAD_ALL.5420  
            ENDIF                                                                  RAD_ALL.5421  
            CONDENSED_RE(L, I, IP_CLCMP_CNV_WATER)                                 RAD_ALL.5422  
     &         =(3.0E+00*TOTAL_MIX_RATIO_CNV(L)*DENSITY_AIR(L, I)                  RAD_ALL.5423  
     &         /(4.0E+00*PI*RHO_WATER*KPARAM*N_DROP(L, I)))                        RAD_ALL.5424  
     &         **(1.0E+00/3.0E+00)                                                 RAD_ALL.5425  
            CONDENSED_RE(L, I, IP_CLCMP_ST_WATER)                                  RAD_ALL.5426  
     &         =(3.0E+00*TOTAL_MIX_RATIO_ST(L)*DENSITY_AIR(L, I)                   RAD_ALL.5427  
     &         /(4.0E+00*PI*RHO_WATER*KPARAM*N_DROP(L, I)))                        RAD_ALL.5428  
     &         **(1.0E+00/3.0E+00)                                                 RAD_ALL.5429  
         ENDDO                                                                     RAD_ALL.5430  
         DO L=1, N_PROFILE                                                         RAD_ALL.5431  
            NTOT_DIAG_G(L, I)=N_DROP(L, I)*1.0E-06                                 RAD_ALL.5432  
            STRAT_LWC_DIAG_G(L, I)                                                 RAD_ALL.5433  
     &         =TOTAL_MIX_RATIO_ST(L)*DENSITY_AIR(L, I)*1.0E03                     RAD_ALL.5434  
         ENDDO                                                                     RAD_ALL.5435  
      ENDDO                                                                        RAD_ALL.5436  
!                                                                                  RAD_ALL.5437  
!     RESET THE EFFECTIVE RADII FOR DEEP CONVECTIVE CLOUDS.                        RAD_ALL.5438  
      DO I=NLEVS+1-NCLDS, NLEVS                                                    RAD_ALL.5439  
         DO L=1, N_PROFILE                                                         RAD_ALL.5440  
            IF (CC_DEPTH(L).GT.DEEP_CONVECTIVE_CLOUD) THEN                         RAD_ALL.5441  
               IF (LAND_G(L)) THEN                                                 RAD_ALL.5442  
                  CONDENSED_RE(L, I, IP_CLCMP_CNV_WATER)=DCONRE_LAND               RAD_ALL.5443  
               ELSE                                                                RAD_ALL.5444  
                  CONDENSED_RE(L, I, IP_CLCMP_CNV_WATER)=DCONRE_SEA                RAD_ALL.5445  
               ENDIF                                                               RAD_ALL.5446  
            ENDIF                                                                  RAD_ALL.5447  
         ENDDO                                                                     RAD_ALL.5448  
      ENDDO                                                                        RAD_ALL.5449  
!                                                                                  RAD_ALL.5450  
!                                                                                  RAD_ALL.5451  
!                                                                                  RAD_ALL.5452  
      RETURN                                                                       RAD_ALL.5453  
      END    
